package com.zettenet.recipesdb.calculator;

import java.math.BigDecimal;
import java.math.MathContext;
import java.math.RoundingMode;

import com.zettenet.recipesdb.calculator.Constants.*;

public class Calculator {
	private static final MathContext mc = new MathContext(10, RoundingMode.HALF_UP);
	
	public static BigDecimal calculate(BigDecimal amount, MeasureVolume volume, MeasureVolume target) {
		return amount.multiply(volume.volume.divide(target.volume, mc));
	}

	public static BigDecimal calculate(BigDecimal amount, MeasureWeight weight, MeasureWeight target) {
		return amount.multiply(weight.weight.divide(target.weight, mc));
	}
	
	public static BigDecimal calculate(BigDecimal amount, MeasureVolume volume, Ingredient ingr, MeasureWeight target) {
		return amount.multiply(volume.volume.multiply(ingr.density).divide(target.weight, mc));
	}
	
	public static BigDecimal calculate(BigDecimal amount, MeasureWeight weight, Ingredient ingr, MeasureVolume target) {
		return amount.multiply(weight.weight.divide(ingr.density, mc).divide(target.volume, mc));
	}
	
	private Calculator() { }
}
