package com.zettenet.recipesdb.calculator;

import java.math.BigDecimal;

public final class Constants {
	private Constants() { }
	
	public static enum Ingredient {
		FLOUR_WHITE			("flour, white",			".528"),
		FLOUR_WHOLEWHEAT	("flour, wholewheat",		".507"),
		
		OIL_OLIVE			("oil, olive",				".918"),
		OIL_VEGETABLE		("oil, vegetable",			".915"),
		OIL_SESAME			("oil, sesame",				".923"),
		//OIL_COCONUT			("oil, coconut",			""),
		//OIL_CORN			("oil, corn",				""),
		
		SALT_TABLE			("salt, table",				"1.154"),
		
		SUGAR_GRANULATED	("sugar, granulated white", ".70"),
		SUGAR_POWDERED		("sugar, powdered white",	".56"),
		
		WATER				("water",					"1");
		
		public final String title;
		public final BigDecimal density;
		
		Ingredient(String title, String density) {
			this.title = title;
			this.density = new BigDecimal(density);
		}
	}
	
	public static enum MeasureVolume {
		CUP_US				("cups, US", 				"236.588237"),
		CUP_METRIC			("cups, metric",			"250"),
		
		PINT_US_LIQUID		("pints, US liquid", 		"473.176473"),
		PINT_US_DRY			("pints, US dry",			"550.610471"),
		PINT_IMPERIAL		("pints, imperial",			"568.26125"),
		
		FLUID_OUNCE			("fluid ounces", 			"29.5735296"),
		
		TABLESPOON			("tablespoons",				"14.7867648"),
		TABLESPOON_AUS		("tablespoons, Aus", 		"20"),
		
		TEASPOON			("teaspoons",				"4.92892159375"),
		
		MILLILITRE			("millilitres",				"1");
		
		public final String title;
		public final BigDecimal volume;
		
		MeasureVolume(String title, String volume) {
			this.title = title;
			this.volume = new BigDecimal(volume);
		}
	}
	
	public static enum MeasureWeight {
		OUNCE				("ounces", 					"28.3495231"),
		POUND				("pounds",					"453.59237"),
		
		GRAM				("grams",					"1");
		
		public final String title;
		public final BigDecimal weight;
		
		MeasureWeight(String title, String weight) {
			this.title = title;
			this.weight = new BigDecimal(weight);
		}
	}
	
}
