package com.zettenet.recipesdb.web;

import org.apache.wicket.Application;
import org.apache.wicket.protocol.http.WebApplication;
import org.apache.wicket.spring.injection.annot.SpringBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;

import com.zettenet.recipesdb.services.IRecipesDataService;
import com.zettenet.recipesdb.web.pages.BasePage;
import com.zettenet.recipesdb.web.pages.Browse;
import com.zettenet.recipesdb.web.pages.Create;
import com.zettenet.recipesdb.web.pages.Recipe;

@Controller
public class RecipesApplication extends WebApplication {

	@SpringBean @Autowired
	private IRecipesDataService recipesDataService;

	public static RecipesApplication get() {
		return (RecipesApplication) Application.get();
	}

	@Override
	public Class<? extends BasePage> getHomePage() {
		return Browse.class;
	}

	@Override
	protected void init() {
		getMarkupSettings().setStripWicketTags(true);

		mountPage("/browse", Browse.class);
		mountPage("/create", Create.class);
		mountPage("/recipe", Recipe.class);
	}

	public IRecipesDataService getRecipesDataService() {
		return this.recipesDataService;
	}

}
