package com.zettenet.recipesdb.web.components;

import java.util.HashSet;
import java.util.Set;

public abstract class ListViewOfSet<T> extends GRepeatingView<T> {
	private static final long serialVersionUID = 5572679722130510259L;
	
	Set<T> items;

	public ListViewOfSet(String id) {
		super(id);
	}

	@Override
	protected void onBeforeRender() {
		if (!hasBeenRendered()) {
			this.items = new HashSet<T>(getModelObject());
			for (T item : items) {
				onPopulateItem(item);
			}
		}
		super.onBeforeRender();
	}

	protected abstract void onPopulateItem(T item);

}
