package com.zettenet.recipesdb.web.components.listEditor;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.apache.wicket.markup.html.form.IFormModelUpdateListener;
import org.apache.wicket.model.IModel;

import com.zettenet.recipesdb.web.components.GRepeatingView;

public abstract class ListEditor<T> extends GRepeatingView<T> implements
		IFormModelUpdateListener {
	private static final long serialVersionUID = -8102134795613896472L;
	
	List<T> items;

	public ListEditor(String id) {
		super(id);
	}

	public ListEditor(String id, IModel<? extends Collection<T>> model) {
		super(id, model);
	}

	public void addItem(T value) {
		this.items.add(value);
		ListEditorItem<T> item = new ListEditorItem<T>(newChildId(),
				this.items.size() - 1);
		add(item);
		onPopulateItem(item);
	}

	@Override
	protected void onBeforeRender() {
		if (!hasBeenRendered()) {
			this.items = new ArrayList<T>(getModelObject());
			for (int i = 0; i < this.items.size(); i++) {
				ListEditorItem<T> li = new ListEditorItem<T>(newChildId(), i);
				add(li);
				onPopulateItem(li);
			}
		}
		super.onBeforeRender();
	}

	protected abstract void onPopulateItem(ListEditorItem<T> item);

	@Override
	public void updateModel() {
		setDefaultModelObject(this.items);
	}
}
