package com.zettenet.recipesdb.web.components.listEditor;

import java.util.List;

import org.apache.wicket.markup.html.form.Button;

public class ListEditorButton extends Button {
	private static final long serialVersionUID = -4259915938540610722L;
	
	private transient ListEditorItem<?> parent;

	public ListEditorButton(String id) {
		super(id);
	}

	protected final ListEditor<?> getEditor() {
		return (ListEditor<?>) getItem().getParent();
	}

	protected final ListEditorItem<?> getItem() {
		if (this.parent == null) {
			this.parent = findParent(ListEditorItem.class);
		}
		return this.parent;
	}

	protected final List<?> getList() {
		return getEditor().items;
	}

	@Override
	protected void onDetach() {
		this.parent = null;
		super.onDetach();
	}

}
