package com.zettenet.recipesdb.web.models;

import java.util.Collections;
import java.util.List;

import org.apache.wicket.model.LoadableDetachableModel;

import com.zettenet.recipesdb.model.Recipe;
import com.zettenet.recipesdb.services.impl.InvalidClientException;
import com.zettenet.recipesdb.web.RecipesApplication;

public class AllRecipesModel extends LoadableDetachableModel<List<Recipe>> {

	private static final long serialVersionUID = 3831334585548319837L;

	@Override
	protected List<Recipe> load() {
		List<Recipe> allRecipes;
		try {
			allRecipes = RecipesApplication.get().getRecipesDataService().getAllRecipes("web");
			Collections.sort(allRecipes);
			return allRecipes;
		} catch (InvalidClientException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return null;
	}

}
