package com.zettenet.recipesdb.web.models;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.apache.wicket.model.CompoundPropertyModel;
import org.apache.wicket.model.IModel;

import com.zettenet.recipesdb.model.Recipe;
import com.zettenet.recipesdb.model.RecipeCategory;
import com.zettenet.recipesdb.model.RecipeCategoryEntry;

public class RecipeCategoriesModel extends
		CompoundPropertyModel<Collection<RecipeCategory>> {
	
	private static final long serialVersionUID = -4285309373266767392L;

	public RecipeCategoriesModel(IModel recipeModel) {
		super(recipeModel);
	}

	@Override
	public List<RecipeCategory> getObject() {
		Recipe recipe = (Recipe) getChainedModel().getObject();
		Set<RecipeCategoryEntry> catEntries = recipe.getCategories();
		List<RecipeCategory> cats = new ArrayList<RecipeCategory>();
		
		for (RecipeCategoryEntry catEntry : catEntries) {
			cats.add(catEntry.getCategory());
		}
		
		Collections.sort(cats);
		return cats;
	}

	@Override
	public void setObject(Collection<RecipeCategory> object) {
		Recipe recipe = (Recipe) getChainedModel().getObject();
		recipe.setCategories(new HashSet<RecipeCategory>(object));
	}

}
