package com.zettenet.recipesdb.web.models;

import org.apache.wicket.model.LoadableDetachableModel;

import com.zettenet.recipesdb.model.Recipe;
import com.zettenet.recipesdb.services.impl.InvalidClientException;
import com.zettenet.recipesdb.services.impl.InvalidDataException;
import com.zettenet.recipesdb.web.RecipesApplication;

public class RecipeLoadableDetachableModel extends
		LoadableDetachableModel<Recipe> {
	private static final long serialVersionUID = -2065333961455755028L;

	private Long recipeId;

	public RecipeLoadableDetachableModel(Long recipeId) {
		super();
		this.recipeId = recipeId;
	}

	@Override
	protected Recipe load() {
		if (this.recipeId == 0) {
			return new Recipe();
		}
		
		try {
			return RecipesApplication.get().getRecipesDataService().getRecipe("web", recipeId);
		} catch (InvalidClientException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InvalidDataException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return null;
	}
}
