package com.zettenet.recipesdb.web.pages;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.link.BookmarkablePageLink;
import org.apache.wicket.model.IModel;
import org.apache.wicket.request.mapper.parameter.PageParameters;

public class BasePage extends WebPage {
	private static final long serialVersionUID = 527928668830399454L;

	public BasePage() {
		initComponents();
	}

	public BasePage(IModel<?> model) {
		super(model);
		initComponents();
	}

	public BasePage(PageParameters params) {
		super(params);
		initComponents();
	}

	private void initComponents() {
		BookmarkablePageLink<Browse> browseLink = new BookmarkablePageLink<Browse>("pgBrowse", Browse.class);
		BookmarkablePageLink<Create> createLink = new BookmarkablePageLink<Create>("pgCreate", Create.class);
		add(browseLink);
		add(createLink);
	}
}
