package com.zettenet.recipesdb.web.pages;

import java.text.ChoiceFormat;
import java.text.Format;
import java.text.MessageFormat;
import java.text.NumberFormat;
import java.util.List;

import org.apache.wicket.markup.html.basic.Label;

import com.zettenet.recipesdb.model.Recipe;
import com.zettenet.recipesdb.web.components.AlphabeticalListView;
import com.zettenet.recipesdb.web.models.AllRecipesModel;

public class Browse extends BasePage {

	List<Recipe> allRecipes;

	private static final String INTROPATTERN = "There {0} in RecipesDB.";
	private static final String[] RECIPECOUNTS = { "are no recipes",
			"is one recipe", "are {0} recipes" };
	private static final double[] RECIPELIMITS = { 0, 1, 2 };

	@SuppressWarnings("unchecked")
	public Browse() {
		AlphabeticalListView<Recipe> recipes = new AlphabeticalListView<Recipe>(
				"recipes", new AllRecipesModel(),
				com.zettenet.recipesdb.web.pages.Recipe.class, "recipes");

		Label intro = new Label(
				"intro",
				getIntroMessage(((List<Recipe>) recipes.getDefaultModelObject())
						.size()));

		add(intro);
		add(recipes);
	}

	private String getIntroMessage(int size) {
		MessageFormat messageForm = new MessageFormat("");

		ChoiceFormat choiceForm = new ChoiceFormat(RECIPELIMITS, RECIPECOUNTS);
		Format[] formats = { choiceForm, null, NumberFormat.getInstance() };

		messageForm.applyPattern(INTROPATTERN);
		messageForm.setFormats(formats);

		Object[] messageArguments = { size };

		return messageForm.format(messageArguments);
	}
}
