package com.zettenet.recipesdb.web.pages;

import org.apache.wicket.model.IModel;
import org.apache.wicket.request.mapper.parameter.PageParameters;

import com.zettenet.recipesdb.web.components.pageContents.RecipeEdit;
import com.zettenet.recipesdb.web.components.pageContents.RecipeView;

public class Recipe extends BasePage {

	public Recipe(PageParameters params) {
		super(params);

		Long recipeId = null;

		if (!params.get("view").isEmpty()) {
			recipeId = Long.parseLong(params.get("view").toString());
			RecipeView recipeView = new RecipeView("recipe", recipeId);
			add(recipeView);
		} else if (!params.get("edit").isEmpty()) {
			recipeId = Long.parseLong(params.get("edit").toString());
			RecipeEdit recipeEdit = new RecipeEdit("recipe", recipeId);
			add(recipeEdit);
		}
	}

	public Recipe(IModel<com.zettenet.recipesdb.model.Recipe> model) {
		super(model);
		RecipeView recipeView = new RecipeView("recipe", model);
		add(recipeView);
	}

}
